<?php

namespace App\Http\Controllers\Auth;

use App\Http\Controllers\Controller;
use App\Models\Anulacion;
use Illuminate\Foundation\Auth\AuthenticatesUsers;
use Illuminate\Http\Request;

use DB;

use App\Models\Clientes;
use App\Models\ClientesUsos;
use App\Models\Facturas;
use App\Models\FacturasDetalles;
use App\Models\NotasDeCredito;
use App\Models\NotasDeCreditoDetalles;
use App\Models\FacturasPdf;


use Illuminate\Support\Facades\Hash;


class AuthController extends Controller
{
    /*
    |--------------------------------------------------------------------------
    | Login Controller
    |--------------------------------------------------------------------------
    |
    | This controller handles authenticating users for the application and
    | redirecting them to your home screen. The controller uses a trait
    | to conveniently provide its functionality to your applications.
    |
    */

    use AuthenticatesUsers;

    /**
     * Where to redirect users after login.
     *
     * @var string
     */
    //Bearer
    protected $redirectTo = "/";
    //https://felwiki.thefactoryhka.com.pa/doku.php?id=enviar

    protected $ruta = "http://demoemision.thefactoryhka.com.pa/ws/obj/v1.0/Service.svc?singleWsdl";

    //http://emision.thefactoryhka.com.pa/ws/obj/v1.0/Service.svc?singleWsdl

    //http://demoemision.thefactoryhka.com.pa/ws/obj/v1.0/Service.svc?singleWsdl

    /**
     * Create a new controller instance.
     *
     * @return void
     */




    public function insertFactura()
    {
        //PRIMERO RECORRO EL LISTADO DE LOS CLIENTES
        $datosCliente = Clientes::select("clie_id", "clie_token", "clie_token2", "clie_ambiente", "clie_produccion")->where("clie_activo", "1")->get();


        foreach ($datosCliente as $clientes) {



            $clie_id = $clientes->clie_id;

            //EMPIEZO A RECORRER  LAS FACTURAS  DEL CLIENTE QUE NO SE HAYAN ENVIADO Y QUE EL TIPO SEA 01 (FACTURA)

            $factura = Facturas::where("facturas.clie_id", "=", $clie_id)->where("facturas.fact_tipo_documento", "=", "01")->where("fact_enviada", "=", "0")->get();



            if ($factura && !count($factura)) {
                echo "No hay Facturas por procesar dl cliente" . $clie_id."<br/>";
            }

            foreach ($factura as $fact) {


                $fact_id = $fact->fact_id;

                //VOY A RECORRER EL DETALLE DE CADA FACTURA PARA ANEXARLO AL ARRAY EN LA SECCION DE ITEMS
                $factura_detalles = FacturasDetalles::where("fact_id", "=", $fact_id)->where("clie_id","=",$clie_id)->get();

                //return  $factura_detalles;
                //LISTA DE ITEM
                $itemsList = [];
                foreach ($factura_detalles as $fact_details) {

                    $itemsList[] = array(
                        "descripcion" => $fact_details->fade_descripcion,
                        "codigo" => $fact_details->fade_codigo,
                        "unidadMedida" => $fact_details->fade_unidad,
                        "cantidad" => $fact_details->fade_cantidad,
                        "precioUnitario" => $fact_details->fade_precio_unitario,
                        "precioUnitarioDescuento" => $fact_details->fade_precio_unitario_descuento,
                        "precioItem" => $fact_details->fade_precio_item,
                        "valorTotal" => $fact_details->fade_valor_total,
                        "tasaITBMS" => $fact_details->fade_tasa_itbms,
                        "valorITBMS" => $fact_details->fade_valor_itbms
                    );
                }


                ///CONSTRUYENDO EL NUEVO JSON  DE 1 FACTURA
                $facturas_tosend = array(

                    "codigoSucursalEmisor" => "0000",
                    "datosTransaccion" =>
                    array(
                        "tipoEmision" => $fact->fact_tipo_emision,
                        "tipoDocumento" => $fact->fact_tipo_documento,
                        "numeroDocumentoFiscal" => $fact->fact_id,
                        "puntoFacturacionFiscal" => $fact->fact_punto_facturacion,
                        "naturalezaOperacion" => $fact->fact_naturaleza_operacion,
                        "tipoOperacion" => $fact->fact_tipo_operacion,
                        "destinoOperacion" => $fact->fact_destino_operacion,
                        "formatoCAFE" => $fact->fact_formato_cafe,
                        "entregaCAFE" => $fact->fact_entrega_cafe,
                        "envioContenedor" => $fact->fact_envio_contenedor,
                        "procesoGeneracion" => $fact->fact_proceso_generacion,
                        "fechaEmision" => date("Y-m-d\TH:i:s-05:00", strtotime($fact->fact_fecha)),
                        "informacionInteres" => $fact->fact_informacion_interes,
                        "cliente" =>
                        array(
                            "tipoClienteFE" => $fact->fact_tipo_cliente,
                            "tipoContribuyente" => $fact->fact_tipo_contribuyente,
                            "codigoUbicacion" => $fact->fact_codigo_ubicacion,
                            "numeroRUC" => $fact->fact_cliente_ruc,
                            "digitoVerificadorRUC" => $fact->fact_cliente_dv,
                            "razonSocial" => $fact->fact_cliente_razon_social,
                            "direccion" => $fact->fact_cliente_direccion,
                            "corregimiento" => $fact->fact_cliente_corregimiento,
                            "distrito" => $fact->fact_cliente_distrito,
                            "provincia" => $fact->fact_cliente_provincia,
                            "telefono1" => $fact->fact_cliente_telefono,
                            "correoElectronico1" => $fact->fact_cliente_correo,
                            "pais" => $fact->fact_cliente_pais
                        ),
                    ),

                    "listaItems" => $itemsList,

                    "totalesSubTotales" =>
                    array(
                        "totalPrecioNeto" => $fact->fact_total_precio_neto,
                        "totalITBMS" => $fact->fact_total_itbms,
                        "totalMontoGravado" => $fact->fact_total_monto_gravado,
                        "totalDescuento" => $fact->fact_descuento,
                        "totalFactura" => $fact->fact_total,
                        "totalValorRecibido" => $fact->fact_valor_recibido,
                        "totalTodosItems" => $fact->fact_total_todos_items,
                        "tiempoPago" => $fact->fact_tiempo_pago,
                        "nroItems" => $fact->fact_numero_items,
                        "listaFormaPago" =>
                        array(
                            array(
                                "formaPagoFact" => $fact->fact_forma_pago,
                                "valorCuotaPagada" => $fact->fact_valor_cuota_pagada,
                                "descFormaPago" => $fact->fact_descripcion_forma_pago
                            )
                        )
                    ),


                );

                $parametros = array(
                    'tokenEmpresa' => $clientes->clie_token,
                    'tokenPassword' => $clientes->clie_token2,
                    'documento' => $facturas_tosend,
                );
                //return json_decode(json_encode($facturas_tosend), true);
                try {
                    $wsPa = new \SoapClient($clientes->clie_ambiente);


                    //A continuación, enviamos el documento al método "Enviar" del Servicio Web de Integración de TFHKA
                    $respWsPa = json_decode(json_encode($wsPa->__soapCall('Enviar', array($parametros))), true);


                    if ($respWsPa["EnviarResult"]["codigo"] == 200) {

                        //ACTUALIZO A ENVIADA Y ACTUALIZO LA FECHA
                        Facturas::where("fact_id", "=", $fact_id)
                            ->update([
                                "fact_fecha_envio" => date("Y-m-d H:i:s"),
                                "fact_enviada" => 1,
                                'fact_produccion' => $clientes->clie_produccion,
                                'fact_cufe' => $respWsPa["EnviarResult"]["cufe"],
                                'fact_qr' => $respWsPa["EnviarResult"]["qr"],
                                'fact_fechaRecepcionDGI' => $respWsPa["EnviarResult"]["fechaRecepcionDGI"],
                                'fact_nroProtocoloAutorizacion' => $respWsPa["EnviarResult"]["nroProtocoloAutorizacion"]
                            ]);

                        //AGREGO A BITACORA
                        ClientesUsos::create(["clie_id" => $clie_id, "clus_fecha" => date("Y-m-d H:i:s"), "clus_tipo" => 1, "fact_id" => $fact_id]);



                        ///METODO PARA DESCARGAR EL PDF Y AGREGAR A LA TABLA DE PDF 
                        $parametrosDescarga = array(
                            'tokenEmpresa' => $clientes->clie_token,
                            'tokenPassword' => $clientes->clie_token2,
                            "datosDocumento" => array(
                                "codigoSucursalEmisor" => "0000",
                                "numeroDocumentoFiscal" => $fact->fact_id,
                                "puntoFacturacionFiscal" => $fact->fact_punto_facturacion,
                                "serialDispositivo" => "",
                                "tipoDocumento" => $fact->fact_tipo_documento,
                                "tipoEmision" => $fact->fact_tipo_emision
                            )
                        );

                        echo "Factura Generada " . $fact->factu_id."<br/>";

                        try {
                            $wsPadESACRGAR = new \SoapClient($clientes->clie_ambiente);


                            //A continuación, enviamos el documento al método "DescargaPDF" del Servicio Web de Integración de TFHKA
                            $respWsPaDes = json_decode(json_encode($wsPadESACRGAR->__soapCall('DescargaPDF', array($parametrosDescarga))), true);

                            if ($respWsPaDes["DescargaPDFResult"]["codigo"] == 200) {
                                FacturasPdf::create(["factu_id" => $fact->factu_id, "fapd_pdf" => $respWsPaDes["DescargaPDFResult"]["documento"]]);
                            }
                            echo "Genero PDF " . $fact->factu_id."<br/>";
                        } catch (\Exception $e) {
                            echo "Genero PDF " .$fact->factu_id."<br/>";
                        }
                    } else {

                        //AGREGO UN COMENTARIO CON EL CODIGO Y EL MENSAJE DE ERROR DE PORQUE NO SE ENVIO
                        Facturas::where("fact_id", "=", $fact_id)->update(["fact_fecha_envio" => date("Y-m-d H:i:s"), "fact_comentario_no_envio" => $respWsPa["EnviarResult"]["codigo"] . "/" . $respWsPa["EnviarResult"]["resultado"] . "/" . $respWsPa["EnviarResult"]["mensaje"]]);
                    }
                } catch (\Exception $e) {
                    echo "Factura error " . $fact->factu_id."<br/>";
                }
            }
        }
    }

    public function insertarNcYCufe()
    {

        //PRIMERO RECORRO EL LISTADO DE LOS CLIENTES
        $datosCliente = Clientes::select("clie_id", "clie_token", "clie_token2", "clie_ambiente")->where("clie_activo", "1")->get();

        foreach ($datosCliente as $clientes) {

            $clie_id = $clientes->clie_id;

            //EMPIEZO A RECORRER  LAS NC  DEL CLIENTE QUE NO SE HAYAN ENVIADO Y QUE EL TIPO SEA 04 (NC)

            $notacredito = NotasDeCredito::where("notas_de_credito.nocre_clie_id", "=", $clie_id)->where("nocre_enviada", "=", "0")->get();
            foreach ($notacredito as $nocre) {

                $nocre_id = $nocre->nocre_id;

                //VOY A RECORRER EL DETALLE DE CADA FACTURA PARA ANEXARLO AL ARRAY EN LA SECCION DE ITEMS
                $nc_detalles = NotasDeCreditoDetalles::where("nocre_nocre_id", "=", $nocre_id)->get();
                //LISTA DE ITEM
                $itemsList = [];
                foreach ($nc_detalles as $nocre_details) {

                    $itemsList[] = array(
                        "descripcion" => $nocre_details->nocrede_descripcion,
                        "codigo" => $nocre_details->nocrede_codigo,
                        "unidadMedida" => $nocre_details->nocrede_unidad,
                        "cantidad" => $nocre_details->nocrede_cantidad,
                        "precioUnitario" => $nocre_details->nocrede_precio_unitario,
                        "precioUnitarioDescuento" => $nocre_details->nocrede_precio_unitario_descuento,
                        "precioItem" => $nocre_details->nocrede_precio_item,
                        "valorTotal" => $nocre_details->nocrede_valor_total,
                        "tasaITBMS" => $nocre_details->nocrede_tasa_itbms,
                        "valorITBMS" => $nocre_details->nocrede_valor_itbms
                    );
                }

                ///CONSTRUYENDO EL NUEVO JSON  DE 1 NC
                $nocre_tosend = array(

                    "codigoSucursalEmisor" => "0000",
                    "datosTransaccion" =>
                    array(
                        "tipoEmision" => $nocre->nocre_tipo_emision,
                        "tipoDocumento" => $nocre->nocre_tipo_documento,
                        "numeroDocumentoFiscal" => $nocre->nocre_id,
                        "puntoFacturacionFiscal" => $nocre->nocre_punto_facturacion,
                        "naturalezaOperacion" => $nocre->nocre_naturaleza_operacion,
                        "tipoOperacion" => $nocre->nocre_tipo_operacion,
                        "destinoOperacion" => $nocre->nocre_destino_operacion,
                        "formatoCAFE" => $nocre->nocre_formato_cafe,
                        "entregaCAFE" => $nocre->nocre_entrega_cafe,
                        "envioContenedor" => $nocre->nocre_envio_contenedor,
                        "procesoGeneracion" => $nocre->nocre_proceso_generacion,
                        "fechaEmision" => date("Y-m-d\TH:i:s-05:00", strtotime($nocre->nocre_fecha)),
                        "informacionInteres" => $nocre->nocre_informacion_interes,
                        "cliente" =>
                        array(
                            "tipoClienteFE" => $nocre->nocre_tipo_cliente,
                            "tipoContribuyente" => $nocre->nocre_tipo_contribuyente,
                            "codigoUbicacion" => $nocre->nocre_codigo_ubicacion,
                            "numeroRUC" => $nocre->nocre_cliente_ruc,
                            "digitoVerificadorRUC" => $nocre->nocre_cliente_dv,
                            "razonSocial" => $nocre->nocre_cliente_razon_social,
                            "direccion" => $nocre->nocre_cliente_direccion,
                            "corregimiento" => $nocre->nocre_cliente_corregimiento,
                            "distrito" => $nocre->nocre_cliente_distrito,
                            "provincia" => $nocre->nocre_cliente_provincia,
                            "telefono1" => $nocre->nocre_cliente_telefono,
                            "correoElectronico1" => $nocre->nocre_cliente_correo,
                            "pais" => $nocre->nocre_cliente_pais
                        ),
                        "listaDocsFiscalReferenciados" =>
                        array(
                            "docFiscalReferenciado" =>
                            array(
                                "fechaEmisionDocFiscalReferenciado" => date("Y-m-d\TH:i:s-05:00", strtotime($nocre->nocre_fechaEmisionDocFiscalReferenciado)),
                                "cufeFEReferenciada" => $nocre->nocre_cufeFEReferenciada,
                                "nroFacturaPapel" => $nocre->nocre_nroFacturaPapel,
                                "nroFacturaImpFiscal" => $nocre->nocre_nroFacturaImpFiscal
                            )
                        )
                    ),

                    "listaItems" => $itemsList,

                    "totalesSubTotales" =>
                    array(
                        "totalPrecioNeto" => $nocre->nocre_total_precio_neto,
                        "totalITBMS" => $nocre->nocre_total_itbms,
                        "totalMontoGravado" => $nocre->nocre_total_monto_gravado,
                        "totalDescuento" => $nocre->nocre_descuento,
                        "totalFactura" => $nocre->nocre_total,
                        "totalValorRecibido" => $nocre->nocre_valor_recibido,
                        "totalTodosItems" => $nocre->nocre_total_todos_items,
                        "tiempoPago" => $nocre->nocre_tiempo_pago,
                        "nroItems" => $nocre->nocre_numero_items,
                        "listaFormaPago" =>
                        array(
                            array(
                                "formaPagoFact" => $nocre->nocre_forma_pago,
                                "valorCuotaPagada" => $nocre->nocre_valor_cuota_pagada,
                                "descFormaPago" => $nocre->nocre_descripcion_forma_pago
                            )
                        )
                    ),


                );

                $parametros = array(
                    'tokenEmpresa' => $clientes->clie_token,
                    'tokenPassword' => $clientes->clie_token2,
                    'documento' => $nocre_tosend,
                );

                //return $parametros;

                try {
                    $wsPa = new \SoapClient($clientes->clie_ambiente);


                    //A continuación, enviamos el documento al método "Enviar" del Servicio Web de Integración de TFHKA
                    $respWsPa = json_decode(json_encode($wsPa->__soapCall('Enviar', array($parametros))), true);


                    if ($respWsPa["EnviarResult"]["codigo"] == 200) {

                        //ACTUALIZO A ENVIADA Y ACTUALIZO LA FECHA
                        NotasDeCredito::where("nocre_id", "=", $nocre_id)
                            ->update([
                                "nocre_fecha_envio" => date("Y-m-d H:i:s"),
                                "nocre_enviada" => 1,
                                'nocre_cufe' => $respWsPa["EnviarResult"]["cufe"],
                                'nocre_qr' => $respWsPa["EnviarResult"]["qr"],
                                'nocre_fechaRecepcionDGI' => $respWsPa["EnviarResult"]["fechaRecepcionDGI"],
                                'nocre_nroProtocoloAutorizacion' => $respWsPa["EnviarResult"]["nroProtocoloAutorizacion"]
                            ]);

                        //AGREGO A BITACORA
                        ClientesUsos::create(["clie_id" => $clie_id, "clus_fecha" => date("Y-m-d H:i:s"), "clus_tipo" => 04, "fact_id" => $nocre_id]);
                    } else {

                        //AGREGO UN COMENTARIO CON EL CODIGO Y EL MENSAJE DE ERROR DE PORQUE NO SE ENVIO
                        NotasDeCredito::where("nocre_id", "=", $nocre_id)->update(["nocre_fecha_envio" => date("Y-m-d H:i:s"), "nocre_comentario_no_envio" => $respWsPa["EnviarResult"]["codigo"] . "/" . $respWsPa["EnviarResult"]["resultado"] . "/" . $respWsPa["EnviarResult"]["mensaje"]]);
                    }

                    echo "NC Generada " . $nocre_id;
                } catch (\Exception $e) {
                    echo "NC Error " . $nocre_id;
                }
            }
        }
    }

    public function insertarAnulaciondeDocs()
    {

        //PRIMERO RECORRO EL LISTADO DE LOS CLIENTES
        $datosCliente = Clientes::select("clie_id", "clie_token", "clie_token2", "clie_ambiente")->where("clie_activo", "1")->get();

        foreach ($datosCliente as $clientes) {

            $clie_id = $clientes->clie_id;

            //EMPIEZO A RECORRER  LAS ANULACIONES, EL DOCUMENTO DEPENDERA DEL TIPO

            $anulacion = Anulacion::where("an_clie_id", "=", $clie_id)->where("an_enviada", "=", "0")->get();
            foreach ($anulacion as $an) {

                $an_id = $an->an_id;

                ///CONSTRUYENDO EL NUEVO JSON  DE 1 ANULACION
                $nocre_tosend = array(
                    "codigoSucursalEmisor" => $an->an_codigoSucursalEmisor,
                    "numeroDocumentoFiscal" => $an->an_numeroDocumentoFiscal,
                    "puntoFacturacionFiscal" => $an->an_puntoFacturacionFiscal,
                    "tipoDocumento" => $an->an_tipoDocumento,
                    "tipoEmision" => $an->an_tipoEmision
                );

                $parametros = array(
                    'tokenEmpresa' => $clientes->clie_token,
                    'tokenPassword' => $clientes->clie_token2,
                    'motivoAnulacion' => $an->an_motivoAnulacion,
                    'datosDocumento' => $nocre_tosend
                );


                //return $parametros;
                try {
                    $wsPa = new \SoapClient($clientes->clie_ambiente);

                    //A continuación, enviamos el documento al método "Enviar" del Servicio Web de Integración de TFHKA

                    $respWsPa = json_decode(json_encode($wsPa->__soapCall('AnulacionDocumento', array($parametros))), true);

                    //return $respWsPa;
                    if ($respWsPa["AnulacionDocumentoResult"]["codigo"] == 200) {

                        //ACTUALIZO A ENVIADA Y ACTUALIZO LA FECHA
                        Anulacion::where("an_id", "=", $an_id)
                            ->update([
                                "an_fecha_envio" => date("Y-m-d H:i:s"),
                                "an_enviada" => 1
                            ]);

                        //AGREGO A BITACORA
                        ClientesUsos::create(["clie_id" => $clie_id, "clus_fecha" => date("Y-m-d H:i:s"), "clus_tipo" => 00, "fact_id" => $an_id]);
                    } else {

                        //AGREGO UN COMENTARIO CON EL CODIGO Y EL MENSAJE DE ERROR DE PORQUE NO SE ENVIO
                        Anulacion::where("an_id", "=", $an_id)->update(["an_fecha_envio" => date("Y-m-d H:i:s"), "an_comentario_no_envio" => $respWsPa["AnulacionDocumentoResult"]["codigo"] . "/" . $respWsPa["AnulacionDocumentoResult"]["resultado"] . "/" . $respWsPa["AnulacionDocumentoResult"]["mensaje"]]);
                    }
                    echo "Anulación Generada " . $an_id;
                } catch (\Exception $e) {
                    echo "Anulación Error " . $an_id;
                }
            }
        }
    }
}
